/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011-2014, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_passwd
#define headerfile_winix_functions_passwd

#include "functionbase.h"
#include "core/user.h"

namespace Winix
{


namespace Fun
{


class Passwd : public FunctionBase
{
public:

	Passwd();
	bool HasAccess();
	void MakeGet();
	void MakePost();

	bool IsPasswordCorrect(const std::wstring & pass, const std::wstring & conf_pass, bool use_ses_log = false);
	bool ChangePassword(long user_id, const std::wstring & new_password);
	bool ResetPassword(const std::wstring & login, long code, bool use_ses_log = false, bool only_check_access = false);

private:

	UserPass up;

	void ChangePassword(User * puser);

	bool ResetPassword(User * puser, long code, bool use_ses_log);
	bool SetNewPassword(User * puser, bool use_ses_log);
	bool ResetPassword(User * puser, long code, bool use_ses_log, bool only_check_access);
	void ResetPassword();
	void ShowResetPasswordForm();

};


} // namespace

} // namespace Winix

#endif
